' Misc Logical functions for Visual Basic.  Version 1.4, by Neil Fraser, July 97.

' Same as VB's IIf(x, a, b) function,
' but does not require MSAFINX.DLL to be installed.
' Note: like IIf(), IfElse() isn't short-circuiting.
'
Function IfElse (x, a, b)
  If x Then IfElse = a Else IfElse = b
End Function

' Return the largest of a or b.
'
Function max2 (a, b)
  If a > b Then max2 = a Else max2 = b
End Function

' Return the largest of a, b or c.
'
Function max3 (a, b, c)
  If a > b Then
    If a > c Then max3 = a Else max3 = c
  Else
    If b > c Then max3 = b Else max3 = c
  End If
End Function

' Force 'value' between lower and upper limits.
' min_max(-4, 7, 9)  =>  7
' min_max(-4, -6, 9) => -4
' min_max(-4, 10, 9) =>  9
'
Function min_max (min, value, max)
  If value < min Then
    min_max = min
  ElseIf value > max Then
    min_max = max
  Else
    min_max = value
  End If
End Function

' Return the smallest of a or b.
'
Function min2 (a, b)
  If a < b Then min2 = a Else min2 = b
End Function

' Return the smallest of a, b or c.
'
Function min3 (a, b, c)
  If a < b Then
    If a < c Then min3 = a Else min3 = c
  Else
    If b < c Then min3 = b Else min3 = c
  End If
End Function

' Return the smallest POSITIVE of a or b.
'
Function minpos2 (a, b)
  If a <= 0 And b <= 0 Then
    minpos2 = 0
  ElseIf a <= 0 Then
    minpos2 = b
  ElseIf b <= 0 Then
    minpos2 = a
  Else
    If a < b Then minpos2 = a Else minpos2 = b
  End If
End Function

' Return the smallest POSITIVE of a, b or c.
'
Function minpos3 (a, b, c)
  If a <= 0 And b <= 0 And c <= 0 Then
    minpos3 = 0
  ElseIf b <= 0 And c <= 0 Then
    minpos3 = a
  ElseIf a <= 0 And c <= 0 Then
    minpos3 = b
  ElseIf a <= 0 And b <= 0 Then
    minpos3 = c
  ElseIf a <= 0 Then
    If b < c Then minpos3 = b Else minpos3 = c
  ElseIf b <= 0 Then
    If a < c Then minpos3 = a Else minpos3 = b
  ElseIf c <= 0 Then
    If a < b Then minpos3 = a Else minpos3 = b
  Else
    If a < b Then
      If a < c Then minpos3 = a Else minpos3 = c
    Else
      If b < c Then minpos3 = b Else minpos3 = c
    End If
  End If
End Function

